package RecaudoPin;

import RecaudoPin.data.sql;
import com.recaudosbancos.service.ConsultaRecaudoResponsesSYCPin;
import com.recaudosbancos.service.NotificacionRecaudoResponsesSYCPin;
import com.recaudosbancos.service.RespuestaReversionPin;
import com.recaudosbancos.service.ServicioRecaudosBancos;
import com.recaudosbancos.service.ServicioRecaudosBancosSoap;
import generated.DetalleRequestPin;
import java.util.ResourceBundle;
import javax.xml.ws.BindingProvider;

public class RecaudoPin {
  public static void main(String[] args) {
    RecaudoPin c = new RecaudoPin();
    c.consultaRecaudoPin("00000074437823", "2019-11-18", "1");
  }
  
  public ConsultaRecaudoResponsesSYCPin consultaRecaudoPin(String referencia, String fechaPago, String numeroConvenio) {
    ConsultaRecaudoResponsesSYCPin response = null;
    try {
      fechaPago = fechaPago.replaceAll("-", "");
      DetalleRequestPin requestPin = getDetalleRequestPin(numeroConvenio);
      requestPin.setPinPago(referencia);
      requestPin.setFechaRecaudo(fechaPago);
      ServicioRecaudosBancos service = new ServicioRecaudosBancos();
      System.out.println("wsdl caqueta ath " + service.getWSDLDocumentLocation());
      ServicioRecaudosBancosSoap port = service.getServicioRecaudosBancosSoap();
      BindingProvider bindingProvider = (BindingProvider)port;
      response = port.consultaRecaudoPin(requestPin);
      if (response != null) {
        System.out.println("codigo de respuesta---" + response.getCodigoRespuestaConsulta());
        System.out.println("IdProducto---" + response.getIdProducto());
        System.out.println("IdTramite---" + response.getIdTramite());
        System.out.println("IdContribuyente---" + response.getIdContribuyente());
        System.out.println("NombreContribuyente---" + response.getNombreContribuyente());
        System.out.println("CodigoDepartamento---" + response.getCodigoDepartamento());
        System.out.println("CodigoMunicipio---" + response.getCodigoMunicipio());
        System.out.println("PlacaVehiculo---" + response.getPlacaVehiculo());
        System.out.println("VigenciaVehiculo---" + response.getVigenciaVehiculo());
        System.out.println("ValorDistribucion80---" + response.getValorDistribucion80());
        System.out.println("ValorDistribucion20---" + response.getValorDistribucion20());
        System.out.println("ValorRecaudoPrincipal---" + response.getValorRecaudoPrincipal());
        System.out.println("ValorRecaudoSecundario---" + response.getValorRecaudoSecundario());
        System.out.println("ValorSistematizacionPrincipal---" + response.getValorSistematizacionPrincipal());
        System.out.println("ValorSistematizacionSecundaria---" + response.getValorSistematizacionSecundaria());
        System.out.println("MontoTotal---" + response.getMontoTotal());
        System.out.println("Mensaje de respuesta---" + response.getMensajeRespuestaConsulta());
        sql sq = new sql();
        if (response.getCodigoRespuestaConsulta().equals("0000")) {
          System.out.println("entraaa");
          sq.insert(response.getIdProducto(), response.getIdTramite(), response.getIdContribuyente(), response
              .getNombreContribuyente(), response.getCodigoDepartamento(), response.getCodigoMunicipio(), response
              .getPlacaVehiculo(), response.getVigenciaVehiculo(), response.getValorDistribucion80(), response
              .getValorDistribucion20(), response.getValorRecaudoPrincipal(), response.getValorRecaudoSecundario(), response
              .getValorSistematizacionPrincipal(), response.getValorSistematizacionSecundaria(), response.getMontoTotal(), numeroConvenio, requestPin
              .getNumeroConvenio());
        } 
      } 
    } catch (Exception e) {
      System.out.println(e.getMessage());
    } 
    return response;
  }
  
  public String formatin(int cant, long var) {
    String concatenar = "%0" + cant + "d";
    String s = String.format(concatenar, new Object[] { Long.valueOf(var) });
    return s;
  }
  
  public NotificacionRecaudoResponsesSYCPin notificacionRecaudoPin(String referencia, String fechaPago, String valorTotal, String numeroConvenio) {
    fechaPago = fechaPago.replaceAll("-", "");
    System.out.println("referencia " + formatin(14, Long.parseLong(referencia)) + " fechapago " + fechaPago + " valorTotal " + valorTotal + " numeroConvenio " + numeroConvenio);
    NotificacionRecaudoResponsesSYCPin response = null;
    try {
      DetalleRequestPin requestPin = getDetalleRequestPin(numeroConvenio);
      requestPin.setPinPago(formatin(14, Long.parseLong(referencia)));
      requestPin.setFechaRecaudo(fechaPago);
      requestPin.setValorTotalRecaudado(valorTotal);
      ServicioRecaudosBancos service = new ServicioRecaudosBancos();
      ServicioRecaudosBancosSoap port = service.getServicioRecaudosBancosSoap();
      System.out.println("wsdl caqueta ath " + service.getWSDLDocumentLocation());
      BindingProvider bindingProvider = (BindingProvider)port;
      response = port.notificacionRecaudoPin(requestPin);
      if (response != null) {
        System.out.println("codigo de respuesta--" + response.getCodigoRespuestaNotificacion());
        System.out.println("respuesta--" + response.getMensajeRespuestaNotificacion());
        if (response.getCodigoRespuestaNotificacion().equals("0000")) {
          sql sq = new sql();
          sq.actualizar(formatin(14, Long.parseLong(referencia)), "1");
        } 
      } 
    } catch (Exception e) {
      System.out.println(e.getMessage());
    } 
    return response;
  }
  
  public RespuestaReversionPin reversionRecaudoPin(String referencia, String fechaPago, String valorTotal, String numeroConvenio) {
    fechaPago = fechaPago.replaceAll("-", "");
    System.out.println("referencia " + formatin(14, Long.parseLong(referencia)) + " fechapago " + fechaPago + " valorTotal " + valorTotal + " numeroConvenio " + numeroConvenio);
    RespuestaReversionPin response = null;
    try {
      DetalleRequestPin requestPin = getDetalleRequestPin(numeroConvenio);
      requestPin.setPinPago(formatin(14, Long.parseLong(referencia)));
      requestPin.setFechaRecaudo(fechaPago);
      requestPin.setValorTotalRecaudado(valorTotal);
      ServicioRecaudosBancos service = new ServicioRecaudosBancos();
      System.out.println("wsdl caqueta ath " + service.getWSDLDocumentLocation());
      ServicioRecaudosBancosSoap port = service.getServicioRecaudosBancosSoap();
      BindingProvider bindingProvider = (BindingProvider)port;
      response = port.reversionRecaudoPin(requestPin);
      if (response != null) {
        System.out.println("codigo de respuesta--" + response.getCodigoRespuestaReversion());
        System.out.println("respuesta--" + response.getMensajeRespuestaReversion());
        if (response.getCodigoRespuestaReversion().equals("0000")) {
          sql sq = new sql();
          sq.actualizar(formatin(14, Long.parseLong(referencia)), "2");
        } 
      } 
    } catch (Exception e) {
      System.out.println(e.getMessage());
    } 
    return response;
  }
  
  protected DetalleRequestPin getDetalleRequestPin(String convenio) {
    ResourceBundle parametros = ResourceBundle.getBundle("config");
    DetalleRequestPin requestPin = new DetalleRequestPin();
    requestPin.setCanal(parametros.getString("canal"));
    requestPin.setCodigoBanco(parametros.getString("codigo_banco"));
    requestPin.setOficinaRecaudo(parametros.getString("oficina_recaudo"));
    if (convenio.equals("1")) {
      requestPin.setNumeroConvenio(parametros.getString("convenio_vehicular"));
    } else if (convenio.equals("2")) {
      requestPin.setNumeroConvenio(parametros.getString("convenio_registro"));
    } 
    return requestPin;
  }
}
